#!/bin/bash 
# This script applies "knot" to list of knot-data.

### Set options for knot program.
######### invariants
# -a -ai -am -c -v [n] -p [vz|lm|xyz] -f -q -cyc -cov [n] -sl2 [p] -grp -kv -sign
######### effects for diagrams
# -alt -mirror [x|y|z] -rot -rotn -mag [n] -knot -braid -ndata -picture [w [h]]
OPTION="-a -ai -am -c -v -p -f -q -cyc -cov -sl2 -sl2 3 -grp -kv -sign"
OPTION="${OPTION} -alt -mirror -mirror y -mirror z -rot -rotn -mag -mag 3 -knot -braid -ndata -picture s"

### which is executable binary of "knot".
KNOT=./knot
#KNOT=./knot_opt

help(){
cat <<EOF
This script applies "knot" to lists.
Usage 1: $0 (files or directories)
  Apply "${KNOT}" to files or files in directories.
Usage 2: $0 < list_of_knots
  Apply "${KNOT}" to files listed in each line.
Note.
  Set _OPTION_ in this script as you need before use this.
  Current option: ${OPTION}
EOF
}

if [ "$1" == "" ]; then xargs -i -r ${KNOT} -if {} ${OPTION}
elif [ -f "$1" ] || [ -d "$1" ] ; then find $@ -type f -maxdepth 1 | xargs -i -r ${KNOT} -if {} ${OPTION}
else help;
fi
exit 0
