/*
2000 Sather version K.Kodama
1996 Kouji KODAMA  IPD-Modula2 to X  interface. 
*/

#include <stdio.h>
#include <stdlib.h>
/* #include <ctype.h> */

/* #include <X11/Xatom.h> */
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Box.h>
/* # include <X11/Xaw/List.h> */
#include "sather.h"

/* c.f. c_header.h
#define true 1
#define false !true
*/

extern void VPara();

static void CheckLog();

static void QuitProc(), repaint(), ResizeWindow(), empty_proc(), 
	FilesSelect(), EditSelect(), EffectSelect(), InvSelect(), OtherSelect(), TrackPointer(), create_pixmap_K();

/* invariants actions */
static void KnotGroup_C(),AlexPoly_C(),ConwayPoly_C(),Ppoly_C(),PpolyLow_C(),Vpoly_C(),Fpoly_C(),
	Qpoly_C(), VpolyPara_C(), AlexPolyM_C(), AlexIdeal_C(),AlexIdealM_C(),
	Covering_C(), Sl2p_C(), GoeritzMat_C(),
	Signature_C(),CyclicPeriod_C(),ThetaGroup_C(),ThetaAlexPoly_C();
/* edit actions */
static void S_Crossing_C(),S_AddCompo_C(),S_NewKnot_C(),S_MoveVert_C(),
	S_Cut_C(),S_DelString_C(),
	S_AddBand_C(),S_BandSurgery_C(),
	S_InvertStr_C(),S_ShiftDiagram_C(),
	S_JumpOver_C(),S_JumpUnder_C();
/* effects */
static void E_Braid_C(), E_nData_C(),E_torus_C(),E_twoBridge_C(),E_pretzel_C(),E_alternate_C(),
	E_coherentBand_C(),E_mag2_C(),E_mag14_C(),E_mag14R_C(),E_mag2R_C(),
	E_mirrorX_C(),E_mirrorY_C(),E_mirrorZ_C(),E_rot_C(),E_rotRev_C(),
	E_backHist_C(),E_fwdHist_C(),E_saveHist_C();
/* files */
static void F_LoadKnot_C(), F_SaveKnot_C(),F_SaveBraid_C(), F_SaveNData_C(),
	F_logSw_C(),F_LaTeXPicture_C(),F_logKnot_C(),F_logBraid_C(), F_logNData_C();
/* other */
static void O_Smooth_C(),O_Lattice_C();


static INT GraphWidthC, GraphHeightC;

static Widget files_entry[30], edit_entry[30], effect_entry[30], inv_entry[30],other_entry[30];

static Display *disp;
static Window canvasWindow;
static Window panedWindow;
static GC gc1,gc2;
static GC gcs[16];/* make a table of GC*/

static Widget toplevel,form,panedx,paned,canvas, 
	files_button, files_menu,
	edit_button, edit_menu,
	effect_button, effect_menu,
	inv_button, inv_menu,
	other_button, other_menu,
	tracker,
	quit_button, 
	currentWidget;


static String files_list[]={
	"Load knot",
	"Save Knot",  "Save Braid",  "Save n-data",  "Save Knot ver.1", 
	"log file: off", "log LaTeX picture", "log Knot", "log Braid", "log n-Data",
};

static String edits_list[]={
	"Crossing", "Add Compo.", "New Knot", "Move Vertex",
	"Cut", "Del string",
	"Add Band", "Band surgery", 
	"Invert string", "Shift Diagram",
	"Jump(over)","Jump(under)",
};

static String effects_list[]={
	"Braid", "n-Data", "Torus link","2-bridge","Pretzel",
	"Alternate", "coherent band",
	"magnify x2", "magnify x1.4", "magnify x0.7", "magnify x0.5",
	"mirror-X", "mirror-Y","mirror-Z","rotateR", "-rotateR",
	"<< Back <<", ">> Forward >>", "force put history",
};

static String inv_list[]={
	"Knot Group", "Alexander poly.","Conway",
	"P-poly.(vz )", "P-poly.low(vz )",
	"Jones V",
	"F-poly.","Q-poly.","V parallel","multi var.alex.poly","Elementary ideal","multi var.ideal",
	"G(K)-->S(n)","G(K)-->sl2(p)", "Knot Value", "Signature",
	"test cyclic period",
	"Theta-3 Group","Theta-3 A.poly.",
	"change P-poly.",
};

static String other_list[]={
	"Smooth Draw: off", "Lattice move: off", "Show restrictions",
	"Show knot data", "Check knot data",
	"Show tcode", "Show tcode theta", 
	"Show braid", "Show ndata",
	"experimental feature",
};

/* SelFile -- File Selection Dialog Package */
/* extern FILE *XsraSelFile(); //obsolete */
extern int XsraSelFile();
String init_path_kr=NULL;
String init_path_kw=NULL;

/*=====================popup WriteKnot=======================*/

static void popup_proc_kw(Widget w,Widget shell)
{
	int            ret;
	String  path_name;
	ret = XsraSelFile(disp, "Set a file name to save knot:",
					  NULL, NULL, init_path_kw, NULL, &path_name);
	if(ret==0){
		if(init_path_kw!=NULL){XtFree(init_path_kw);}
		init_path_kw=path_name;
		/* (void)KNOTXW_WriteKnotN(str,strlen(str)+1); */
		(void)WriteKnotN(init_path_kw,strlen(init_path_kw)+1);
		repaint();
	}
}

/*=====================popup Braid WriteKnot=======================*/

static void popup_proc_b_kw(Widget w,Widget shell)
{
	int            ret;
	String  path_name;
	ret = XsraSelFile(disp, "Set a file name to save braid:",
					  NULL, NULL, init_path_kw, NULL, &path_name);
	if(ret==0){
		if(init_path_kw!=NULL){XtFree(init_path_kw);}
		init_path_kw=path_name;
		(void)WriteBraidN(init_path_kw,strlen(init_path_kw)+1);
		repaint();
	}
}

/*=====================popup n-diagram WriteKnot=======================*/

static void popup_proc_nd_kw(Widget w,Widget shell)
{
	int            ret;
	String  path_name;
	ret = XsraSelFile(disp, "Set a file name to save n-data:",
					  NULL, NULL, init_path_kw, NULL, &path_name);
	if(ret==0){
		if(init_path_kw!=NULL){XtFree(init_path_kw);}
		init_path_kw=path_name;
		(void)WriteNDataN(init_path_kw,strlen(init_path_kw)+1);
		repaint();
	}
}


/*=====================popup ver1 form WriteKnot=======================*/

static void popup_proc_v1_kw(Widget w,Widget shell)
{
	int            ret;
	String  path_name;
	ret = XsraSelFile(disp, "Set a file name to save knot ver.1 binary form:",
					  NULL, NULL, init_path_kw, NULL, &path_name);
	if(ret==0){
		if(init_path_kw!=NULL){XtFree(init_path_kw);}
		init_path_kw=path_name;
		(void)WriteKnotNVer1(init_path_kw,strlen(init_path_kw)+1);
		repaint();
	}
}

/*=====================popup ReadKnot=======================*/


/* ========== obsolete  ============== 
static void popup_proc_kr_ord(Widget w,Widget shell)
{
	String str;
	FILE *fp;
	fp=XsraSelFile(toplevel, "Select a file to read: ",
				   "Ok", "Cancel", "Can't open file: ", init_path_kr, "r", NULL, &str);
	if(fp!=NULL){
		init_path_kr=str;
		fclose(fp);
		// (void)KNOTXW_ReadKnotN(str,strlen(str)+1);
		(void)ReadKnotN(str,strlen(str)+1);
		repaint();
	}
}
====================================== */

static void popup_proc_kr(Widget w,Widget shell)
{
	int            ret;
	String  path_name;
	ret = XsraSelFile(disp, "Select a file to read: ",
					  "OK", "Cancel", init_path_kr, NULL, &path_name);
	if(ret==0){
		if(init_path_kr!=NULL){XtFree(init_path_kr);}
		init_path_kr=path_name;
		// init_path_kr=XtNewString(path_name);
		// printf("fname to read is [%s].\n", init_path_kr);
		(void)ReadKnotN(init_path_kr,strlen(init_path_kr)+1);
		repaint();
	}
}

/*=====================popup Representaions=======================*/
static Widget popup_rep_shell, popup_rep_form, 
	popup_rep_dialog, 
	popup_rep_label,popup_rep_text,
	popup_rep_paned,
	popup_rep_hb,
	popup_rep_hu,
	popup_rep_ind,
	popup_rep_lk,
	popup_rep_knotgrp,
	popup_rep_twistAlex,
	popup_rep_covd,
	popup_rep_covd_y,
	popup_rep_covd_br,
	popup_rep_covd_hb,
	popup_rep_covd_hu,
	popup_rep_f;

static int rep_n=3,rep_f=2,
	/* Folllowings are boolean values(0/-1) */
	rep_hb=0,rep_hu=0,rep_ind=0,rep_lk=0,rep_knotgrp=0, rep_twistAlex=0,
    rep_covd=0, rep_covd_y=0,rep_covd_br=0,rep_covd_lk=0,rep_covd_hb=0,rep_covd_hu=0;


static void rep_proc_rep_setlabels()
{
	char s[50],str[50];
/**/
	rep_covd_y = rep_covd;
	rep_covd_br = rep_ind && rep_covd;
	rep_covd_lk = rep_lk && rep_covd;
	rep_covd_hb = rep_hb && rep_covd;
	rep_covd_hu = rep_hu && rep_covd;
/**/
	if(rep_covd_y){ sprintf(str, "Search G(K)-->S(n), CovD-Y.");
	}else{ sprintf(str, "Search G(K)-->S(n).        ");
	}
	XtVaSetValues(popup_rep_dialog, XtNlabel,str,NULL);
/**/
	if(rep_covd){sprintf(s, "H1(br.cover),CovD-H1b: ");
	}else{ sprintf(s, "H1(br.cover): ");
	}
	if (rep_hb){ sprintf(str, "%s  on",s);}else{sprintf(str, "%s off",s);}
	XtVaSetValues(popup_rep_hb, XtNlabel,str,NULL);
/**/
	if(rep_covd){sprintf(s, "H1(unbr.cover),CovD-H1u: ");
	}else{ sprintf(s, "H1(unbr.cover): ");
	}
	if (rep_hu){ sprintf(str, "%s  on",s);}else{sprintf(str, "%s off",s);}
	XtVaSetValues(popup_rep_hu, XtNlabel,str,NULL);
/**/
	if(rep_covd){ sprintf(s, "Branch index,CovD-Br: ");
	}else{ sprintf(s, "Branch index: ");
	}
	if (rep_ind){ sprintf(str, "%s  on",s);}else{sprintf(str, "%s off",s);}
	XtVaSetValues(popup_rep_ind, XtNlabel,str,NULL);
/**/
	if(rep_covd){ sprintf(s, "Covering linkage,CovD-Lk: ");
 	}else{ sprintf(s, "Covering linkage: ");
	}
	if (rep_lk){ sprintf(str, "%s  on",s);}else{sprintf(str, "%s off",s);}
	XtVaSetValues(popup_rep_lk, XtNlabel,str,NULL);
/**/
 	sprintf(s, "Fundamental group(cover): ");
	if (rep_knotgrp){ sprintf(str, "%s  on",s);
	}else{sprintf(str, "%s off",s);
	}
	XtVaSetValues(popup_rep_knotgrp, XtNlabel,str,NULL);
/**/
 	sprintf(s, "twisted Alexander polynomial: ");
	if (rep_twistAlex){ sprintf(str, "%s  on",s);
	}else{sprintf(str, "%s off",s);
	}
	XtVaSetValues(popup_rep_twistAlex, XtNlabel,str,NULL);
/**/
 	sprintf(s, "Covering distributions: ");
	if (rep_covd){ sprintf(str, "%s  on",s);
	}else{sprintf(str, "%s off",s);
	}
	XtVaSetValues(popup_rep_covd, XtNlabel,str,NULL);

 	sprintf(s, "form: ");
	sprintf(str, "%s %d",s,rep_f);
	XtVaSetValues(popup_rep_f, XtNlabel,str,NULL);
}


static void popup_rep_proc(Widget w,Widget shell)
{
	static char str[50];

	sprintf(str,"%d",rep_n);
	XtVaSetValues(popup_rep_text, XtNstring, (String)str,NULL);
	rep_proc_rep_setlabels();
	XtPopup(shell, XtGrabNone);
}


static void rep_popdown_proc(Widget w, Widget shell)
{
	String str;

	XtPopdown(shell);
	XtVaGetValues(popup_rep_text,XtNstring,&str,NULL);
	rep_n=atoi(str);
	/*
	  KNOTXW_RepSearch(rep_n,rep_f,rep_ind,rep_lk,rep_hb,rep_hu,rep_knotgrp,rep_twistAlex,
				  rep_covd_y,rep_covd_br,rep_covd_lk,rep_covd_hb,rep_covd_hu);
	*/
	RepSearch(rep_n,rep_f,rep_ind,rep_lk,rep_hb,rep_hu,rep_knotgrp,rep_twistAlex,
				  rep_covd_y,rep_covd_br,rep_covd_lk,rep_covd_hb,rep_covd_hu);
	repaint();
}


static void proc_rep_hb(Widget w, Widget shell)
{
	rep_hb= !rep_hb; rep_proc_rep_setlabels();
}

static void proc_rep_hu(Widget w, Widget shell)
{
	rep_hu= !rep_hu; rep_proc_rep_setlabels();
}

static void proc_rep_ind(Widget w, Widget shell)
{
	rep_ind= !rep_ind; rep_proc_rep_setlabels();
}

static void proc_rep_lk(Widget w, Widget shell)
{
	rep_lk= !rep_lk; rep_proc_rep_setlabels();
}

static void proc_rep_knotgrp(Widget w, Widget shell)
{
	rep_knotgrp= !rep_knotgrp; rep_proc_rep_setlabels();
}
static void proc_rep_twistAlex(Widget w, Widget shell)
{
	rep_twistAlex= !rep_twistAlex; rep_proc_rep_setlabels();
}


static void proc_rep_covd(Widget w, Widget shell)
{
	rep_covd = !rep_covd;
	rep_proc_rep_setlabels();
}


static void proc_rep_f(Widget w, Widget shell)
{
	rep_f= 3-rep_f; rep_proc_rep_setlabels();
}


static void rep_popdown_cancel_proc(Widget w, Widget shell)
{
	XtPopdown(shell);
}


/*=====================popup SL2P =======================*/
static Widget popup_sl2p_shell, popup_sl2p_form, 
  popup_sl2p_dialog,
  popup_sl2p_label,
  popup_sl2p_text;


static void popup_proc_sl2p(Widget w,Widget shell)
{
	static char str[50];
	int sl2p_n;
	sl2p_n=2; sprintf(str,"%d",sl2p_n);
	XtVaSetValues(popup_sl2p_text, XtNstring, (String)str,NULL);
	XtPopup(shell, XtGrabNone);
}

static void popdown_proc_sl2p(Widget w, Widget shell)
{
  String str;
	int sl2p_n;
	XtPopdown(shell);
	XtVaGetValues(popup_sl2p_text,XtNstring,&str,NULL);
	sl2p_n=atoi(str);
	/*KNOTXW_RepSL2pSearch(sl2p_n,1,1);*/
	RepSL2pSearch(sl2p_n,1,1);
	repaint();
}

static void popdown_cancel_proc_sl2p(Widget w, Widget shell)
{
	XtPopdown(shell);
}
/*=====================popup V para=======================*/
static Widget popup_paraV_shell, popup_paraV_form, 
  popup_paraV_dialog,
  popup_paraV_label,
  popup_paraV_text;


static void popup_proc_paraV(Widget w,Widget shell)
{
	static char str[50];
	int paraV_n;
	paraV_n=2; sprintf(str,"%d",paraV_n);
	XtVaSetValues(popup_paraV_text, XtNstring, (String)str,NULL);
	XtPopup(shell, XtGrabNone);
}

static void popdown_proc_paraV(Widget w, Widget shell)
{
  String str;
	INT paraV_n;
	XtPopdown(shell);
	XtVaGetValues(popup_paraV_text,XtNstring,&str,NULL);
	paraV_n=atoi(str);
	/*KNOTXW_VPara(paraV_n);*/
	VPara(paraV_n);
	repaint();
}

static void popdown_cancel_proc_paraV(Widget w, Widget shell)
{
	XtPopdown(shell);
}


/*=====================popup BRAID=======================*/
static Widget popup_br_shell, popup_br_form, popup_br_dialog, popup_br_text,
popup_br_paned, popup_br_artinform, popup_br_pack,popup_br_reduction, popup_br_close;


static void proc_braid_close_disp(void)
{
	char str[50];
	if(	is_closeBraid() ){ sprintf(str,"close: on");
	}else{ sprintf(str,"close: off");
	}
	XtVaSetValues(popup_br_close, XtNlabel, (String)str,NULL);
}

static void proc_braid_pack_disp(void)
{
	char str[50];
	/*if(	KNOTXW_is_packBraid() ){ sprintf(str,"pack: on");*/
	if(	is_packBraid() ){ sprintf(str,"pack: on");
	}else{ sprintf(str,"pack: off");
	}
	XtVaSetValues(popup_br_pack, XtNlabel, (String)str,NULL);
}

static void popup_proc_br(Widget w,Widget shell)
{
	unsigned char reply;
	char * word;

	/*
	  KNOTXW_spackBraid(true); proc_braid_pack_disp();
	  KNOTXW_Knot2BraidWord(&word);
	*/
	spackBraid(TRUE); proc_braid_pack_disp();
	scloseBraid(TRUE); proc_braid_close_disp();
	Knot2BraidWord(&word);
	XtVaSetValues(popup_br_text, XtNstring, (String)word,NULL);
	XtPopup(shell, XtGrabNone);
}


static void popdown_proc_br(Widget w, Widget shell)
{
	String str;
	unsigned char reply;
	char * strptr;
	XtPopdown(shell);
	XtVaGetValues(popup_br_text,XtNstring,&str,NULL);
	strptr=str;
	/*reply=KNOTXW_BraidWord2Knot(strptr);*/
	reply=BraidWord2Knot(strptr);
	repaint();
}

static void popdown_cancel_proc_br(Widget w, Widget shell)
{
	XtPopdown(shell);
}


static void proc_braid_pack(Widget w, Widget shell)
{
	/*
	  if(KNOTXW_is_packBraid()){KNOTXW_spackBraid(false);
	  }else{KNOTXW_spackBraid(true);
	  }
  */
  if(is_packBraid()){spackBraid(FALSE);
  }else{spackBraid(TRUE);
  }
  /* reverse */
	proc_braid_pack_disp();
}

static void proc_braid_close(Widget w, Widget shell)
{
	if(is_closeBraid()){scloseBraid(FALSE);
	}else{scloseBraid(TRUE);
	}
	proc_braid_close_disp();
}

static void proc_braid_rartin(Widget w, Widget shell)
{
	String str;
	unsigned char reply;
	char * strptr;

	XtVaGetValues(popup_br_text,XtNstring,&str,NULL);
	/*reply=KNOTXW_BraidWord2RArtinNormalForm(str,&strptr);*/
	reply=BraidWord2RArtinNormalForm(str,&strptr);
	XtVaSetValues(popup_br_text, XtNstring, (String)strptr,NULL);
	/*KNOTXW_spackBraid(false);*/ 	/* 1/0 */
	spackBraid(FALSE); 	/* 1/0 */
	proc_braid_pack_disp();
}


static void proc_braid_reduction(Widget w, Widget shell)
{
	String str;
	unsigned char reply;
	int l,l1;
	char * strptr;

	XtVaGetValues(popup_br_text,XtNstring,&str,NULL);
	/*reply=KNOTXW_BraidWord2RBraidWord(str,&strptr);*/
	reply=BraidWord2RBraidWord(str,&strptr);
	XtVaSetValues(popup_br_text, XtNstring, (String)strptr,NULL);
}


/*=====================popup NData=======================*/
static Widget popup_nd_shell, popup_nd_form, popup_nd_dialog, popup_nd_text;

static void popup_proc_nd(Widget w,Widget shell)
{
	unsigned char reply;
	char * word;

	/*reply=KNOTXW_Knot2NDataStr(&word);*/
	reply=Knot2NDataStr(&word);
	XtVaSetValues(popup_nd_text, XtNstring, (String)word,NULL);
	XtPopup(shell, XtGrabNone);
}

static void popdown_proc_nd(Widget w, Widget shell)
{
	String str;
	char * strptr;
	XtPopdown(shell);
	XtVaGetValues(popup_nd_text,XtNstring,&str,NULL);
	strptr=str;
	/*(void)KNOTXW_NDataStr2Knot(strptr);*/
	(void)NDataStr2Knot(strptr);
	repaint();
}

static void popdown_cancel_proc_nd(Widget w, Widget shell)
{
	XtPopdown(shell);
}


/*=====================popup Torus=======================*/
static Widget popup_torus_shell, popup_torus_form, popup_torus_dialog, popup_torus_text;

static void popup_proc_torus(Widget w,Widget shell)
{
	XtVaSetValues(popup_torus_text, XtNstring, "2 2 endcode" ,NULL);
	XtPopup(shell, XtGrabNone);
}

static void popdown_proc_torus(Widget w, Widget shell)
{
	String str;
	char * strptr;
	XtPopdown(shell);
	XtVaGetValues(popup_torus_text,XtNstring,&str,NULL);
	strptr=str;
	/*(void)KNOTXW_TorusStr2Knot(strptr);*/
	(void)TorusStr2Knot(strptr);
	repaint();
}

static void popdown_cancel_proc_torus(Widget w, Widget shell)
{
	XtPopdown(shell);
}


/*=====================popup TwoBridge=======================*/
static Widget popup_2bridge_shell, popup_2bridge_form, popup_2bridge_dialog, popup_2bridge_text;

static void popup_proc_2bridge(Widget w,Widget shell)
{
	XtVaSetValues(popup_2bridge_text, XtNstring, "c: 2 2 endcode" ,NULL);
	XtPopup(shell, XtGrabNone);
}

static void popdown_proc_2bridge(Widget w, Widget shell)
{
	String str;
	char * strptr;
	XtPopdown(shell);
	XtVaGetValues(popup_2bridge_text,XtNstring,&str,NULL);
	strptr=str;
	/*(void)KNOTXW_TwoBridgeStr2Knot(strptr);*/
	(void)TwoBridgeStr2Knot(strptr);
	repaint();
}

static void popdown_cancel_proc_2bridge(Widget w, Widget shell)
{
	XtPopdown(shell);
}


/*=====================popup Pretzel=======================*/
static Widget popup_pretzel_shell, popup_pretzel_form, popup_pretzel_dialog, popup_pretzel_text;

static void popup_proc_pretzel(Widget w,Widget shell)
{
	XtVaSetValues(popup_pretzel_text, XtNstring, "2 2 endcode" ,NULL);
	XtPopup(shell, XtGrabNone);
}

static void popdown_proc_pretzel(Widget w, Widget shell)
{
	String str;
	char * strptr;
	XtPopdown(shell);
	XtVaGetValues(popup_pretzel_text,XtNstring,&str,NULL);
	strptr=str;
	/*(void)KNOTXW_PretzelStr2Knot(strptr);*/
	(void)PretzelStr2Knot(strptr);
	repaint();
}

static void popdown_cancel_proc_pretzel(Widget w, Widget shell)
{
	XtPopdown(shell);
}


/*================popup  Log LaTeX DrawKnotPic========================*/
static Widget popup_tex_shell, popup_tex_form, popup_tex_dialog, 
popup_tex_w_label, popup_tex_w_text,
popup_tex_h_label, popup_tex_h_text,
popup_tex_m_label, popup_tex_m_text,
popup_tex_mode;

static int tex_width=120,tex_height=80,tex_margin=0,tex_mode=1;

static void proc_tex_setlabels()
{
	unsigned char str[50];
	if(tex_mode==1){ sprintf(str, "Centering");
	}else if(tex_mode==2){ sprintf(str, "Adjust area");
	}
	XtVaSetValues(popup_tex_mode, XtNlabel,str,NULL);
}

static void popup_proc_tex(Widget w,Widget shell)
{
	unsigned char str[50];
	int reply;

#define tpic_num 6
	/*reply=KNOTXW_FilesSelectM(tpic_num);*/
	reply=FilesSelectM(tpic_num);
	CheckLog();
	if(reply!=1){ return; }
	sprintf(str,"%d",tex_width); XtVaSetValues(popup_tex_w_text, XtNstring, (String)str,NULL);
	sprintf(str,"%d",tex_height); XtVaSetValues(popup_tex_h_text, XtNstring, (String)str,NULL);
	sprintf(str,"%d",tex_margin); XtVaSetValues(popup_tex_m_text, XtNstring, (String)str,NULL);
	proc_tex_setlabels();
	XtPopup(shell, XtGrabNone);
}

static void popdown_proc_tex(Widget w, Widget shell)
{
	String str;

	XtPopdown(shell);
	XtVaGetValues(popup_tex_w_text,XtNstring,&str,NULL);  tex_width=atoi(str);
	XtVaGetValues(popup_tex_h_text,XtNstring,&str,NULL);  tex_height=atoi(str);
	XtVaGetValues(popup_tex_m_text,XtNstring,&str,NULL);  tex_margin=atoi(str);
	/*(void)KNOTXW_DrawKnotPic(tex_width,tex_height,tex_margin,tex_mode);*/
	(void)DrawKnotPic(tex_width,tex_height,tex_margin,tex_mode);
	repaint();
}

static void popdown_cancel_proc_tex(Widget w, Widget shell)
{
	XtPopdown(shell);
}

static void proc_tex_mode(Widget w, Widget shell)
{
	tex_mode=3-tex_mode; proc_tex_setlabels();
}


/*=================================================*/
static struct _app_resources { String line_kStr, line_tStr, line_rtStr, line_kMark; } app_resources;

static XtResource resources[]={
#define offset(entry) XtOffset(struct _app_resources*, entry)
{ "lineKString", "LineKString", XtRString, sizeof(String),offset(line_kStr), XtRString, "black"},
{"lineTString", "LineTString", XtRString, sizeof(String),offset(line_tStr), XtRString, "green"},
{"lineRTString", "LineRTString", XtRString, sizeof(String),offset(line_rtStr), XtRString, "magenta"},
{"lineKMark", "LineKMark", XtRString, sizeof(String),offset(line_kMark), XtRString, "magenta"},
#undef offset
};

static XtActionsRec actions[]= {
	/* GUI */
	{ "QuitProc", (XtActionProc)QuitProc},
	{ "TrackPointer", (XtActionProc)TrackPointer },
	{ "repaint", (XtActionProc)repaint },
	{ "ResizeWindow", (XtActionProc)ResizeWindow },
	{ "empty_proc", (XtActionProc)empty_proc },
	/* Invariant */
	{ "KnotGroup", (XtActionProc)KnotGroup_C},
	{ "AlexPoly", (XtActionProc)AlexPoly_C},
	{ "ConwayPoly", (XtActionProc)ConwayPoly_C},
	{ "Ppoly", (XtActionProc)Ppoly_C },
	{ "PpolyLow", (XtActionProc)PpolyLow_C},
	{ "Vpoly", (XtActionProc)Vpoly_C},
	{ "Fpoly", (XtActionProc)Fpoly_C},
	{ "Qpoly", (XtActionProc)Qpoly_C},
	{ "VpolyPara", (XtActionProc)VpolyPara_C},
	{ "ApexPolyM",  (XtActionProc)AlexPolyM_C},
	{ "AlexIdeal", (XtActionProc)AlexIdeal_C},
	{ "AlexIdealM", (XtActionProc)AlexIdealM_C},
	{ "Covering", (XtActionProc)Covering_C},
	{ "sl2p", (XtActionProc)Sl2p_C},
	{ "GoeritzMat", (XtActionProc)GoeritzMat_C},
	{ "Signature", (XtActionProc)Signature_C},
	{ "CyclicPeriod", (XtActionProc)CyclicPeriod_C},
	{ "ThetaGroup", (XtActionProc)ThetaGroup_C},
	{ "ThetaAlexPoly", (XtActionProc)ThetaAlexPoly_C},
	/* Edit */
	{ "Crossing" , (XtActionProc)S_Crossing_C},
	{ "AddCompo", (XtActionProc)S_AddCompo_C},
	{ "NewKnot", (XtActionProc)S_NewKnot_C},
	{ "MoveVert", (XtActionProc)S_MoveVert_C},
	{ "Cut", (XtActionProc)S_Cut_C},
	{ "DelString", (XtActionProc)S_DelString_C},
	{ "AddBand", (XtActionProc)S_AddBand_C},
	{ "BandSurgery", (XtActionProc)S_BandSurgery_C},
	{ "InvertStr", (XtActionProc)S_InvertStr_C},
	{ "ShiftDiagram", (XtActionProc)S_ShiftDiagram_C},
	{ "JumpOver", (XtActionProc)S_JumpOver_C},
	{ "JumpUnder", (XtActionProc)S_JumpUnder_C},
	/* Effect */
	{ "Braid", (XtActionProc)E_Braid_C},
	{ "nData", (XtActionProc)E_nData_C},
	{ "Torus", (XtActionProc)E_torus_C},
	{ "Bridge2", (XtActionProc)E_twoBridge_C},
	{ "Pretzel", (XtActionProc)E_pretzel_C},
	{ "Alternate", (XtActionProc)E_alternate_C},
	{ "Coherent", (XtActionProc)E_coherentBand_C},
	{ "Mag2", (XtActionProc)E_mag2_C},
	{ "Mag14", (XtActionProc)E_mag14_C},
	{ "Mag14R", (XtActionProc)E_mag14R_C},
	{ "Mag2R", (XtActionProc)E_mag2R_C},
	{ "MirrorX", (XtActionProc)E_mirrorX_C},
	{ "MirrorY", (XtActionProc)E_mirrorY_C},
	{ "MirrorZ", (XtActionProc)E_mirrorZ_C},
	{ "Rot", (XtActionProc)E_rot_C},
	{ "RotR", (XtActionProc)E_rotRev_C},
	{ "BackHist", (XtActionProc)E_backHist_C},
	{ "FwdHist", (XtActionProc)E_fwdHist_C},
	{ "SaveHist", (XtActionProc)E_saveHist_C},
	/* file */
	{ "LoadKnot",  (XtActionProc)F_LoadKnot_C},
	{ "SaveKnot",  (XtActionProc)F_SaveKnot_C},
	{ "SaveBraid",  (XtActionProc)F_SaveBraid_C},
	{ "SaveNData",  (XtActionProc)F_SaveNData_C},
	{ "LogSw",  (XtActionProc)F_logSw_C},
	{ "LaTeXPicture",  (XtActionProc)F_LaTeXPicture_C},
	{ "LogKnot",  (XtActionProc)F_logKnot_C},
	{ "LogBraid",  (XtActionProc)F_logBraid_C},
	{ "LogNData",  (XtActionProc)F_logNData_C},
	/* other */
	{ "SmoothDraw",  (XtActionProc)O_Smooth_C},
	{ "LatticeMove",  (XtActionProc)O_Lattice_C},
};

static XrmOptionDescRec options[]={
{"-lineks", ".lineKString", XrmoptionSepArg, NULL},
{"-linets", ".lineTString", XrmoptionSepArg, NULL},
{"-linerts", ".lineRTString", XrmoptionSepArg, NULL},
{"-linekm", ".lineKMark", XrmoptionSepArg, NULL},
};


static String fallback_resources[]={
"selFile*international: False",
"*canvas.width: 400",
"*canvas.height: 400",
"*canvas.borderWidth: 3",
"*canvas.cursor: arrow",
"*canvas.translations: #override\\n\
<BtnDown>: TrackPointer()\\n\
<BtnUp> : TrackPointer()\\n\
<Motion>: TrackPointer()\\n\
<Expose>: repaint()\\n\
<Configure>: ResizeWindow()",
"*showGrip: off",
/*"*paned.fromHoriz: canvas",*/
"*canvas.fromHoriz: paned",
"*files_button.label: Files",
"*files_button.justify: Left",
"*files_button.menuName: files_menu",
"*edit_button.label: Edit: Add components.",
"*edit_button.justify: Left",
"*edit_button.menuName: edit_menu",
"*effect_button.label: Effects on diagram",
"*effect_button.justify: Left",
"*effect_button.menuName: effect_menu",
"*inv_button.label: Invariants",
"*inv_button.justify: Left",
"*inv_button.menuName: inv_menu",
"*other_button.label: Other options",
"*other_button.justify: Left",
"*other_button.menuName: other_menu",
"*tracker.borderWidth: 0",
"*tracker.label: (x y)=( 0  0 )",
"*quit_button.label: Quit",
/**/
"*popup_rep_shell.title: ---KNOT--- Representation",
"*popup_rep_dialog.label: Search G(K)-->S(n).",
"*popup_rep_dialog.borderWidth: 0",
"*popup_rep_label.fromVert: popup_rep_dialog",
"*popup_rep_label.label: S(n): n=",
"*popup_rep_label.borderWidth: 0",
"*popup_rep_text.fromHoriz: popup_rep_label",
"*popup_rep_text.fromVert: popup_rep_dialog",
"*popup_rep_text.width: 40",
"*popup_rep_text.height: 20",
"*popup_rep_text*editType: edit",
"*popup_rep_text.translations: #override\\n\
<Key>Return: empty_proc()",
"*popup_rep_paned.fromVert: popup_rep_label",
"*popup_rep_paned.fromVert: popup_rep_text",
"*popup_rep_paned_hb.label: 012345678901234567890123456789012345",
/**/
"*popup_sl2p_shell.title: ---KNOT--- SL2(p) representaion",
"*popup_sl2p_dialog.label: Experimental version. Search G(K)-->SL2(p)",
"*popup_sl2p_dialog.borderWidth: 0",
"*popup_sl2p_label.fromVert: popup_sl2p_dialog",
"*popup_sl2p_label.label: prime number=",
"*popup_sl2p_label.borderWidth: 0",
"*popup_sl2p_text.fromHoriz: popup_sl2p_label",
"*popup_sl2p_text.fromVert: popup_sl2p_dialog",
"*popup_sl2p_text.width: 40",
"*popup_sl2p_text.height: 20",
"*popup_sl2p_text*editType: edit",
"*popup_sl2p_text.translations: #override\\n\
<Key>Return: empty_proc()",
/**/
"*popup_paraV_shell.title: ---KNOT--- V parallel",
"*popup_paraV_dialog.label: V(parallel link)",
"*popup_paraV_dialog.borderWidth: 0",
"*popup_paraV_label.fromVert: popup_paraV_dialog",
"*popup_paraV_label.label: multiplicity=",
"*popup_paraV_label.borderWidth: 0",
"*popup_paraV_text.fromHoriz: popup_paraV_label",
"*popup_paraV_text.fromVert: popup_paraV_dialog",
"*popup_paraV_text.width: 40",
"*popup_paraV_text.height: 20",
"*popup_paraV_text*editType: edit",
"*popup_paraV_text.translations: #override\\n\
<Key>Return: empty_proc()",
/**/
"*popup_br_shell.title: ---KNOT--- Braid word",
"*popup_br_dialog.label: Braid: set braid word.",
"*popup_br_dialog.borderWidth: 0",
"*popup_br_paned.fromVert: popup_br_dialog",
"*popup_br_text.fromVert: popup_br_paned",
"*popup_br_text.width: 500",
"*popup_br_text.height: 160",
"*popup_br_text*editType: edit",
"*popup_br_text*scrollVertical: WhenNeeded",
"*popup_br_artinform.label: Generalized Artin's normal form",
"*popup_br_pack.label: pack  on",
"*popup_br_close.label: close  on",
"*popup_br_reduction.label: try reduction",
/**/
"*popup_nd_shell.title: ---KNOT--- n-Data",
"*popup_nd_dialog.label: n-Data: set n-data word.",
"*popup_nd_dialog.borderWidth: 0",
"*popup_nd_text.fromVert: popup_nd_dialog",
"*popup_nd_text.width: 500",
"*popup_nd_text.height: 160",
"*popup_nd_text*editType: edit",
"*popup_nd_text*scrollVertical: WhenNeeded",
/**/
"*popup_torus_shell.title: ---KNOT--- torus link",
"*popup_torus_dialog.label: torus T(p, q).",
"*popup_torus_dialog.borderWidth: 0",
"*popup_torus_text.fromVert: popup_torus_dialog",
"*popup_torus_text.width: 500",
"*popup_torus_text.height: 160",
"*popup_torus_text*editType: edit",
"*popup_torus_text*scrollVertical: WhenNeeded",
/**/
"*popup_2bridge_shell.title: ---KNOT--- 2-Bridge",
"*popup_2bridge_dialog.label: Conway's form c: a0 a1 ... or Schubert's form s: p q.",
"*popup_2bridge_dialog.borderWidth: 0",
"*popup_2bridge_text.fromVert: popup_2bridge_dialog",
"*popup_2bridge_text.width: 500",
"*popup_2bridge_text.height: 160",
"*popup_2bridge_text*editType: edit",
"*popup_2bridge_text*scrollVertical: WhenNeeded",
/**/
"*popup_pretzel_shell.title: ---KNOT--- Pretzel",
"*popup_pretzel_dialog.label: Pretzel P(a0,a1,...).",
"*popup_pretzel_dialog.borderWidth: 0",
"*popup_pretzel_text.fromVert: popup_pretzel_dialog",
"*popup_pretzel_text.width: 500",
"*popup_pretzel_text.height: 160",
"*popup_pretzel_text*editType: edit",
"*popup_pretzel_text*scrollVertical: WhenNeeded",
/**/
"*popup_tex_shell.title: ---KNOT--- LaTeX-picture/tpic",
"*popup_tex_dialog.label: Knot diagram in LaTeX picture.",
"*popup_tex_dialog.borderWidth: 0",
"*popup_tex_w_label.fromVert: popup_tex_dialog",
"*popup_tex_w_label.borderWidth: 0",
"*popup_tex_w_label.label: width(mm)=",
"*popup_tex_w_text.fromVert: popup_tex_dialog",
"*popup_tex_w_text.fromHoriz: popup_tex_w_label",
"*popup_tex_w_text.width: 40",
"*popup_tex_w_text.height: 20",
"*popup_tex_w_text*editType: edit",
"*popup_tex_w_text.translations: #override\\n<Key>Return: empty_proc()",
"*popup_tex_h_label.fromVert: popup_tex_w_label",
"*popup_tex_h_label.fromVert: popup_tex_w_text",
"*popup_tex_h_label.borderWidth: 0",
"*popup_tex_h_label.label: height(mm)=",
"*popup_tex_h_text.fromVert: popup_tex_w_lavel",
"*popup_tex_h_text.fromVert: popup_tex_w_text",
"*popup_tex_h_text.fromHoriz: popup_tex_h_label",
"*popup_tex_h_text.width: 40",
"*popup_tex_h_text.height: 20",
"*popup_tex_h_text*editType: edit",
"*popup_tex_h_text.translations: #override\\n\
<Key>Return: empty_proc()",
"*popup_tex_m_label.fromVert: popup_tex_h_label",
"*popup_tex_m_label.fromVert: popup_tex_h_text",
"*popup_tex_m_label.borderWidth: 0",
"*popup_tex_m_label.label: margin(mm)=",
"*popup_tex_m_text.fromVert: popup_tex_h_label",
"*popup_tex_m_text.fromVert: popup_tex_h_text",
"*popup_tex_m_text.fromHoriz: popup_tex_m_label",
"*popup_tex_m_text.width: 40",
"*popup_tex_m_text.height: 20",
"*popup_tex_m_text*editType: edit",
"*popup_tex_m_text.translations: #override\\n\
<Key>Return: empty_proc()",
"*popup_tex_mode.fromVert: popup_tex_m_label",
"*popup_tex_mode.fromVert: popup_tex_m_text",
"*popup_tex_mode.label: Adjust area size",
"*popup_tex_mode.width: 100",
"*popup_tex_mode.height: 20",
NULL,
};


static void SetAppData(int argc, char **argv)
{
	XColor def, closest;
	
	XtVaGetApplicationResources(toplevel, (caddr_t)&app_resources,resources, XtNumber(resources), NULL);
	disp = XtDisplay(toplevel);
	{ 
		int i;
		for(i=0; i<16; i++){ gcs[i]=XCreateGC(disp, RootWindow(disp,0),0, NULL); }
	}
	XtVaGetValues(toplevel,XtNbackground,&closest.pixel,NULL);
	XSetForeground(disp, gcs[0],closest.pixel);
	XAllocNamedColor(disp, DefaultColormap(disp,0),app_resources.line_kStr, &def, &closest);
	XSetForeground(disp, gcs[1], closest.pixel);
	XAllocNamedColor(disp, DefaultColormap(disp,0),app_resources.line_tStr, &def, &closest);
	XSetForeground(disp, gcs[2], closest.pixel);
	XAllocNamedColor(disp, DefaultColormap(disp,0),app_resources.line_rtStr, &def, &closest);
	XSetForeground(disp, gcs[3], closest.pixel);
	XAllocNamedColor(disp, DefaultColormap(disp,0),app_resources.line_kMark, &def, &closest);
	XSetForeground(disp, gcs[9], closest.pixel);
	XSetFunction(disp, gcs[9], GXxor);
} 

/* Athna widget main function */
void knotXProc(int argc,char **argv)
{
	XtAppContext app_con;
	int i;

	String ag[]={
		"self",
		"-xrm",
		"*inputMethod: none",
		NULL,
	};
	int an=3;

	toplevel = XtVaAppInitialize(&app_con, "Knot", 
								 options, XtNumber(options),&an,ag,fallback_resources, NULL);
	SetAppData(argc, argv);
	/* &an,ag */
	form = XtVaCreateManagedWidget("form",formWidgetClass, toplevel, NULL);
	paned = XtVaCreateManagedWidget("paned", panedWidgetClass, form, NULL);
	canvas = XtVaCreateManagedWidget("canvas", widgetClass, form, NULL);
/******* files *******/
	files_button = XtVaCreateManagedWidget("files_button",menuButtonWidgetClass, paned,NULL);
	files_menu = XtVaCreatePopupShell("files_menu",simpleMenuWidgetClass, files_button,NULL);
	for( i=0; (int)XtNumber(files_list)>i; i++){
		files_entry[i] = XtVaCreateManagedWidget(files_list[i],smeBSBObjectClass, files_menu,NULL);
		XtAddCallback(files_entry[i], XtNcallback, FilesSelect,(XtPointer)i);
	}
	CheckLog();
/******* knot edit *******/
	edit_button = XtVaCreateManagedWidget("edit_button",menuButtonWidgetClass, paned,NULL);
	edit_menu = XtVaCreatePopupShell("edit_menu",simpleMenuWidgetClass, edit_button,NULL);
	for( i=0; (int)XtNumber(edits_list)>i; i++){
		edit_entry[i] = XtVaCreateManagedWidget(edits_list[i],smeBSBObjectClass, edit_menu,NULL);
		XtAddCallback(edit_entry[i], XtNcallback, EditSelect,(XtPointer)i);
	}
/******* knot effect *******/
	effect_button = XtVaCreateManagedWidget("effect_button",menuButtonWidgetClass, paned,NULL);
	effect_menu = XtVaCreatePopupShell("effect_menu",simpleMenuWidgetClass, effect_button,NULL);
	for( i=0; (int)XtNumber(effects_list)>i; i++){
		effect_entry[i] = XtVaCreateManagedWidget(effects_list[i],smeBSBObjectClass, effect_menu,NULL);
		XtAddCallback(effect_entry[i], XtNcallback, EffectSelect,(XtPointer)i);
	}
/******* invariants *******/
	inv_button = XtVaCreateManagedWidget("inv_button",menuButtonWidgetClass, paned,NULL);
	inv_menu = XtVaCreatePopupShell("inv_menu",simpleMenuWidgetClass, inv_button,NULL);
	for( i=0; (int)XtNumber(inv_list)>i; i++){
		inv_entry[i] = XtVaCreateManagedWidget(inv_list[i],smeBSBObjectClass, inv_menu,NULL);
		XtAddCallback(inv_entry[i], XtNcallback, InvSelect,(XtPointer)i);
	}
/******* other options *******/
	other_button = XtVaCreateManagedWidget("other_button",menuButtonWidgetClass, paned,NULL);
	other_menu = XtVaCreatePopupShell("other_menu",simpleMenuWidgetClass, other_button,NULL);
	for( i=0; (int)XtNumber(other_list)>i; i++){
		other_entry[i] = XtVaCreateManagedWidget(other_list[i],smeBSBObjectClass, other_menu,NULL);
		XtAddCallback(other_entry[i], XtNcallback, OtherSelect,(XtPointer)i);
	}
/*******tracker*******/
	tracker=XtVaCreateManagedWidget("tracker",labelWidgetClass, paned,NULL);
/*******quit*******/
	quit_button = XtVaCreateManagedWidget("quit_button",commandWidgetClass, paned,NULL);
	XtAddCallback(quit_button, XtNcallback, QuitProc, canvas);
/******* popup ReadKnot*******/
	XtRemoveAllCallbacks(files_entry[0],XtNcallback);
	XtAddCallback(files_entry[0],XtNcallback,(XtCallbackProc)popup_proc_kr,toplevel);
/******* popup WriteKnot*******/
	XtRemoveAllCallbacks(files_entry[1],XtNcallback);
	XtAddCallback(files_entry[1],XtNcallback,(XtCallbackProc)popup_proc_kw,toplevel);
/******* popup Braid WriteKnot*******/
	XtRemoveAllCallbacks(files_entry[2],XtNcallback);
	XtAddCallback(files_entry[2],XtNcallback,(XtCallbackProc)popup_proc_b_kw,toplevel);
/******* popup n-data WriteKnot*******/
	XtRemoveAllCallbacks(files_entry[3],XtNcallback);
	XtAddCallback(files_entry[3],XtNcallback,(XtCallbackProc)popup_proc_nd_kw,toplevel);
/******* popup WriteKnot  ver.1 *******/
	XtRemoveAllCallbacks(files_entry[4],XtNcallback);
	XtAddCallback(files_entry[4],XtNcallback,(XtCallbackProc)popup_proc_v1_kw,toplevel);
/******* popup TeX  *******/
	popup_tex_shell=XtVaCreatePopupShell("popup_tex_shell",topLevelShellWidgetClass, toplevel,NULL);
	popup_tex_form=XtVaCreateManagedWidget("popup_tex_form",formWidgetClass,popup_tex_shell,NULL);
	popup_tex_dialog=XtVaCreateManagedWidget("popup_tex_dialog",dialogWidgetClass, popup_tex_form,NULL);
	popup_tex_w_label=XtVaCreateManagedWidget("popup_tex_w_label",labelWidgetClass,popup_tex_form,NULL);
	popup_tex_w_text=XtVaCreateManagedWidget("popup_tex_w_text",asciiTextWidgetClass,popup_tex_form,NULL);
	popup_tex_h_label=XtVaCreateManagedWidget("popup_tex_h_label",labelWidgetClass,popup_tex_form,NULL);
	popup_tex_h_text=XtVaCreateManagedWidget("popup_tex_h_text",asciiTextWidgetClass,popup_tex_form,NULL);
	popup_tex_m_label=XtVaCreateManagedWidget("popup_tex_m_label",labelWidgetClass,popup_tex_form,NULL);
	popup_tex_m_text=XtVaCreateManagedWidget("popup_tex_m_text",asciiTextWidgetClass,popup_tex_form,NULL);
	popup_tex_mode=XtVaCreateManagedWidget("popup_tex_mode",commandWidgetClass,popup_tex_form,NULL);
	XawDialogAddButton(popup_tex_dialog,"Cancel",(XtCallbackProc)popdown_cancel_proc_tex,popup_tex_shell);
	XawDialogAddButton(popup_tex_dialog,"OK",(XtCallbackProc)popdown_proc_tex,popup_tex_shell);
	XtAddCallback(popup_tex_mode, XtNcallback, (XtCallbackProc)proc_tex_mode, popup_tex_mode);
	XtRemoveAllCallbacks(files_entry[6],XtNcallback);
	XtAddCallback(files_entry[6],XtNcallback,(XtCallbackProc)popup_proc_tex,popup_tex_shell);
/******* REP & Covering *******/
	popup_rep_shell=XtVaCreatePopupShell("popup_rep_shell",topLevelShellWidgetClass, toplevel,NULL);
	popup_rep_form=XtVaCreateManagedWidget("popup_rep_form",formWidgetClass,popup_rep_shell,NULL);
	popup_rep_dialog=XtVaCreateManagedWidget("popup_rep_dialog",dialogWidgetClass,popup_rep_form,NULL);
	popup_rep_label=XtVaCreateManagedWidget("popup_rep_label",labelWidgetClass,popup_rep_form,NULL);
	popup_rep_text=XtVaCreateManagedWidget("popup_rep_text",asciiTextWidgetClass,popup_rep_form,NULL);
	popup_rep_paned=XtVaCreateManagedWidget("popup_rep_paned",panedWidgetClass,popup_rep_form,NULL);
	popup_rep_hb=XtVaCreateManagedWidget("popup_rep_hb",commandWidgetClass,popup_rep_paned,NULL);
	popup_rep_hu=XtVaCreateManagedWidget("popup_rep_hu",commandWidgetClass,popup_rep_paned,NULL);
	popup_rep_ind=XtVaCreateManagedWidget("popup_rep_ind",commandWidgetClass,popup_rep_paned,NULL);
	popup_rep_lk=XtVaCreateManagedWidget("popup_rep_lk",commandWidgetClass,popup_rep_paned,NULL);
	popup_rep_knotgrp=XtVaCreateManagedWidget("popup_rep_knotgrp",commandWidgetClass,popup_rep_paned,NULL);
	popup_rep_twistAlex=XtVaCreateManagedWidget("popup_rep_twistAlex",commandWidgetClass,popup_rep_paned,NULL);
	popup_rep_covd=XtVaCreateManagedWidget("popup_rep_covd",commandWidgetClass,popup_rep_paned,NULL);
	popup_rep_f=XtVaCreateManagedWidget("popup_rep_f",commandWidgetClass,popup_rep_paned,NULL);
	XawDialogAddButton(popup_rep_dialog,"Cancel",(XtCallbackProc)rep_popdown_cancel_proc,popup_rep_shell);
	XawDialogAddButton(popup_rep_dialog,"OK",(XtCallbackProc)rep_popdown_proc,popup_rep_shell);

	XtAddCallback(popup_rep_hb, XtNcallback, (XtCallbackProc)proc_rep_hb, popup_rep_shell);
	XtAddCallback(popup_rep_hu, XtNcallback, (XtCallbackProc)proc_rep_hu, popup_rep_shell);
	XtAddCallback(popup_rep_ind, XtNcallback, (XtCallbackProc)proc_rep_ind, popup_rep_shell);
	XtAddCallback(popup_rep_lk, XtNcallback, (XtCallbackProc)proc_rep_lk, popup_rep_shell);
	XtAddCallback(popup_rep_knotgrp, XtNcallback, (XtCallbackProc)proc_rep_knotgrp, popup_rep_shell);
	XtAddCallback(popup_rep_twistAlex, XtNcallback, (XtCallbackProc)proc_rep_twistAlex, popup_rep_shell);
	XtAddCallback(popup_rep_covd, XtNcallback, (XtCallbackProc)proc_rep_covd, popup_rep_shell);
	XtAddCallback(popup_rep_f, XtNcallback, (XtCallbackProc)proc_rep_f, popup_rep_shell);
	XtRemoveAllCallbacks(inv_entry[12],XtNcallback);
	XtAddCallback(inv_entry[12],XtNcallback,(XtCallbackProc)popup_rep_proc,popup_rep_shell);
/******* popup sl2p  *******/
	popup_sl2p_shell=XtVaCreatePopupShell("popup_sl2p_shell",topLevelShellWidgetClass, toplevel,NULL);
	popup_sl2p_form=XtVaCreateManagedWidget("popup_sl2p_form",formWidgetClass,popup_sl2p_shell,NULL);
	popup_sl2p_dialog=XtVaCreateManagedWidget("popup_sl2p_dialog",dialogWidgetClass, popup_sl2p_form,NULL);
	popup_sl2p_label=XtVaCreateManagedWidget("popup_sl2p_label",labelWidgetClass,popup_sl2p_form,NULL);
	popup_sl2p_text=XtVaCreateManagedWidget("popup_sl2p_text",asciiTextWidgetClass,popup_sl2p_form,NULL);
	XawDialogAddButton(popup_sl2p_dialog,"Cancel",(XtCallbackProc)popdown_cancel_proc_sl2p,popup_sl2p_shell);
	XawDialogAddButton(popup_sl2p_dialog,"OK",(XtCallbackProc)popdown_proc_sl2p,popup_sl2p_shell);
	XtRemoveAllCallbacks(inv_entry[13],XtNcallback);
	XtAddCallback(inv_entry[13],XtNcallback,(XtCallbackProc)popup_proc_sl2p,popup_sl2p_shell);
/******* popup paraV  *******/
	popup_paraV_shell=XtVaCreatePopupShell("popup_paraV_shell",topLevelShellWidgetClass, toplevel,NULL);
	popup_paraV_form=XtVaCreateManagedWidget("popup_paraV_form",formWidgetClass,popup_paraV_shell,NULL);
	popup_paraV_dialog=XtVaCreateManagedWidget("popup_paraV_dialog",dialogWidgetClass, popup_paraV_form,NULL);
	popup_paraV_label=XtVaCreateManagedWidget("popup_paraV_label",labelWidgetClass,popup_paraV_form,NULL);
	popup_paraV_text=XtVaCreateManagedWidget("popup_paraV_text",asciiTextWidgetClass,popup_paraV_form,NULL);
	XawDialogAddButton(popup_paraV_dialog,"Cancel",(XtCallbackProc)popdown_cancel_proc_paraV,popup_paraV_shell);
	XawDialogAddButton(popup_paraV_dialog,"OK",(XtCallbackProc)popdown_proc_paraV,popup_paraV_shell);
	XtRemoveAllCallbacks(inv_entry[8],XtNcallback);
	XtAddCallback(inv_entry[8],XtNcallback,(XtCallbackProc)popup_proc_paraV,popup_paraV_shell);
/******* popup BRAID  *******/
	popup_br_shell=XtVaCreatePopupShell("popup_br_shell",topLevelShellWidgetClass, toplevel,NULL);
	popup_br_form=XtVaCreateManagedWidget("popup_br_form",formWidgetClass,popup_br_shell,NULL);
	popup_br_dialog=XtVaCreateManagedWidget("popup_br_dialog",dialogWidgetClass, popup_br_form,NULL);
	popup_br_paned=XtVaCreateManagedWidget("popup_br_paned",panedWidgetClass,popup_br_form,NULL);
	popup_br_text=XtVaCreateManagedWidget("popup_br_text",asciiTextWidgetClass,popup_br_form,NULL);
	XawDialogAddButton(popup_br_dialog,"Cancel",(XtCallbackProc)popdown_cancel_proc_br,popup_br_shell);
	XawDialogAddButton(popup_br_dialog,"OK",(XtCallbackProc)popdown_proc_br,popup_br_shell);
	popup_br_artinform=XtVaCreateManagedWidget("popup_br_artinform",commandWidgetClass,popup_br_paned,NULL);
	XtAddCallback(popup_br_artinform, XtNcallback, (XtCallbackProc)proc_braid_rartin, popup_br_shell);
	popup_br_pack=XtVaCreateManagedWidget("popup_br_pack",commandWidgetClass,popup_br_paned,NULL);
	XtAddCallback(popup_br_pack, XtNcallback, (XtCallbackProc)proc_braid_pack, popup_br_shell);
	popup_br_close=XtVaCreateManagedWidget("popup_br_close",commandWidgetClass,popup_br_paned,NULL);
	XtAddCallback(popup_br_close, XtNcallback, (XtCallbackProc)proc_braid_close, popup_br_shell);
	popup_br_reduction=XtVaCreateManagedWidget("popup_br_reduction",commandWidgetClass,popup_br_paned,NULL);
	XtAddCallback(popup_br_reduction, XtNcallback,(XtCallbackProc)proc_braid_reduction, popup_br_shell);
	XtRemoveAllCallbacks(effect_entry[0],XtNcallback);
	XtAddCallback(effect_entry[0],XtNcallback,(XtCallbackProc)popup_proc_br,popup_br_shell);
	/******* popup NData  *******/
	popup_nd_shell=XtVaCreatePopupShell("popup_nd_shell",topLevelShellWidgetClass, toplevel,NULL);
	popup_nd_form=XtVaCreateManagedWidget("popup_nd_form",formWidgetClass,popup_nd_shell,NULL);
	popup_nd_dialog=XtVaCreateManagedWidget("popup_nd_dialog",dialogWidgetClass, popup_nd_form,NULL);
	popup_nd_text=XtVaCreateManagedWidget("popup_nd_text",asciiTextWidgetClass,popup_nd_form,NULL);
	XawDialogAddButton(popup_nd_dialog,"Cancel",(XtCallbackProc)popdown_cancel_proc_nd,popup_nd_shell);
	XawDialogAddButton(popup_nd_dialog,"OK",(XtCallbackProc)popdown_proc_nd,popup_nd_shell);
	XtRemoveAllCallbacks(effect_entry[1],XtNcallback);
	XtAddCallback(effect_entry[1],XtNcallback,(XtCallbackProc)popup_proc_nd,popup_nd_shell);
	/******* popup Torus  *******/
	popup_torus_shell=XtVaCreatePopupShell("popup_torus_shell",topLevelShellWidgetClass, toplevel,NULL);
	popup_torus_form=XtVaCreateManagedWidget("popup_torus_form",formWidgetClass,popup_torus_shell,NULL);
	popup_torus_dialog=XtVaCreateManagedWidget("popup_torus_dialog",dialogWidgetClass, popup_torus_form,NULL);
	popup_torus_text=XtVaCreateManagedWidget("popup_torus_text",asciiTextWidgetClass,popup_torus_form,NULL);
	XawDialogAddButton(popup_torus_dialog,"Cancel",(XtCallbackProc)popdown_cancel_proc_torus,popup_torus_shell);
	XawDialogAddButton(popup_torus_dialog,"OK",(XtCallbackProc)popdown_proc_torus,popup_torus_shell);
	XtRemoveAllCallbacks(effect_entry[2],XtNcallback);
	XtAddCallback(effect_entry[2],XtNcallback,(XtCallbackProc)popup_proc_torus,popup_torus_shell);
	/******* popup Two Bridge  *******/
	popup_2bridge_shell=XtVaCreatePopupShell("popup_2bridge_shell",topLevelShellWidgetClass, toplevel,NULL);
	popup_2bridge_form=XtVaCreateManagedWidget("popup_2bridge_form",formWidgetClass,popup_2bridge_shell,NULL);
	popup_2bridge_dialog=XtVaCreateManagedWidget("popup_2bridge_dialog",dialogWidgetClass, popup_2bridge_form,NULL);
	popup_2bridge_text=XtVaCreateManagedWidget("popup_2bridge_text",asciiTextWidgetClass,popup_2bridge_form,NULL);
	XawDialogAddButton(popup_2bridge_dialog,"Cancel",(XtCallbackProc)popdown_cancel_proc_2bridge,popup_2bridge_shell);
	XawDialogAddButton(popup_2bridge_dialog,"OK",(XtCallbackProc)popdown_proc_2bridge,popup_2bridge_shell);
	XtRemoveAllCallbacks(effect_entry[3],XtNcallback);
	XtAddCallback(effect_entry[3],XtNcallback,(XtCallbackProc)popup_proc_2bridge,popup_2bridge_shell);
	/******* popup Pretzel  *******/
	popup_pretzel_shell=XtVaCreatePopupShell("popup_pretzel_shell",topLevelShellWidgetClass, toplevel,NULL);
	popup_pretzel_form=XtVaCreateManagedWidget("popup_pretzel_form",formWidgetClass,popup_pretzel_shell,NULL);
	popup_pretzel_dialog=XtVaCreateManagedWidget("popup_pretzel_dialog",dialogWidgetClass, popup_pretzel_form,NULL);
	popup_pretzel_text=XtVaCreateManagedWidget("popup_pretzel_text",asciiTextWidgetClass,popup_pretzel_form,NULL);
	XawDialogAddButton(popup_pretzel_dialog,"Cancel",(XtCallbackProc)popdown_cancel_proc_pretzel,popup_pretzel_shell);
	XawDialogAddButton(popup_pretzel_dialog,"OK",(XtCallbackProc)popdown_proc_pretzel,popup_pretzel_shell);
	XtRemoveAllCallbacks(effect_entry[4],XtNcallback);
	XtAddCallback(effect_entry[4],XtNcallback,(XtCallbackProc)popup_proc_pretzel,popup_pretzel_shell);
	/**/

	XtAppAddActions(app_con, actions, XtNumber(actions));
	XtRealizeWidget(toplevel);
	canvasWindow = XtWindow(canvas);
	create_pixmap_K(canvas); ResizeWindow();
	XtAppMainLoop(app_con);
}


static void QuitProc(){
	KNOTXW_endprogram();
	exit(0);
}

static void empty_proc(){
}


static void CheckLog(){
	char str[50];
	int reply;
	reply=LogIsEnabled();
	if (reply==1){ sprintf(str, "log file: on");
	}else{ sprintf(str, "log file: off");
	}
	XtVaSetValues(files_entry[5], XtNlabel,str,NULL);
}

static void FilesSelect(Widget w, int selection){
	/*reply=KNOTXW_FilesSelectM(selection);*/
	(void)FilesSelectM(selection);
	CheckLog();
}
/* file actions*/
static void F_LoadKnot_C(){popup_proc_kr(toplevel, toplevel);}//0
static void F_SaveKnot_C(){popup_proc_kw(toplevel, toplevel);}//1
static void F_SaveBraid_C(){popup_proc_b_kw(toplevel, popup_br_shell);}//2
static void F_SaveNData_C(){popup_proc_nd_kw(toplevel, popup_br_shell);}//3
//4 Save Knot ver.1
static void F_logSw_C(){(void)FilesSelectM(5);}
static void F_LaTeXPicture_C(){popup_proc_tex(toplevel,popup_tex_shell);} //6
static void F_logKnot_C(){(void)FilesSelectM(7);}
static void F_logBraid_C(){(void)FilesSelectM(8);}
static void F_logNData_C(){(void)FilesSelectM(9);}

static void EditSelect(Widget w, int selection)
{
	char str[50];
	int reply;
	/* printf("EditSelect: selection=%d\n", selection); */
	/*reply=KNOTXW_EditSelectM(selection);*/
	reply=EditSelectM(selection);
	sprintf(str, "Edit Mode: %s", edits_list[reply]);
	XtVaSetValues(edit_button, XtNlabel,str,NULL);
}
/* edit actions */
static void S_Crossing_C(){EditSelect(toplevel,0);}
static void S_AddCompo_C(){EditSelect(toplevel,1);}
static void S_NewKnot_C(){EditSelect(toplevel,2);}
static void S_MoveVert_C(){EditSelect(toplevel,3);}
static void S_Cut_C(){EditSelect(toplevel,4);}
static void S_DelString_C(){EditSelect(toplevel,5);}
static void S_AddBand_C(){EditSelect(toplevel,6);}
static void S_BandSurgery_C(){EditSelect(toplevel,7);}
static void S_InvertStr_C(){EditSelect(toplevel,8);}
static void S_ShiftDiagram_C(){EditSelect(toplevel,9);}
static void S_JumpOver_C(){EditSelect(toplevel,10);}
static void S_JumpUnder_C(){EditSelect(toplevel,11);}


static void EffectSelect(Widget w, int selection)
{
	int reply;
	/*reply=KNOTXW_EffectSelectM(selection);*/
	reply=EffectSelectM(selection);
}
/* effcts */
static void E_Braid_C(){popup_proc_br(toplevel, popup_br_shell);} //0
static void E_nData_C(){popup_proc_nd(toplevel, popup_nd_shell);} //1
static void E_torus_C(){popup_proc_torus(toplevel, popup_torus_shell);} //2
static void E_twoBridge_C(){popup_proc_2bridge(toplevel, popup_2bridge_shell);} //3
static void E_pretzel_C(){popup_proc_pretzel(toplevel, popup_pretzel_shell);} //4
static void E_alternate_C(){(void)EffectSelectM(5);}
static void E_coherentBand_C(){(void)EffectSelectM(6);}
static void E_mag2_C(){(void)EffectSelectM(7);}
static void E_mag14_C(){(void)EffectSelectM(8);}
static void E_mag14R_C(){(void)EffectSelectM(9);}
static void E_mag2R_C(){(void)EffectSelectM(10);}
static void E_mirrorX_C(){(void)EffectSelectM(11);}
static void E_mirrorY_C(){(void)EffectSelectM(12);}
static void E_mirrorZ_C(){(void)EffectSelectM(13);}
static void E_rot_C(){(void)EffectSelectM(14);}
static void E_rotRev_C(){(void)EffectSelectM(15);}
static void E_backHist_C(){(void)EffectSelectM(16);}
static void E_fwdHist_C(){(void)EffectSelectM(17);}
static void E_saveHist_C(){(void)EffectSelectM(18);}


static void InvSelect(Widget w, int selection)
{
	int reply;
	char str1[50],str2[50];
	XtPopdown(inv_menu);
	/*reply=KNOTXW_InvSelectM(selection);*/
	reply=InvSelectM(selection);
	if(selection==19){
		switch(reply){
		case 1:sprintf(str1,"P-poly.(vz)");  sprintf(str2,"P-poly.low (vz)");break;
		case 2:sprintf(str1,"P-poly.(lm)");  sprintf(str2,"P-poly.low (lm)");break;
		case 3:sprintf(str1,"P-poly.(xyz)"); sprintf(str2,"P-poly.low (xyz)");break;
		default: ;  /* error? */
		}
		XtVaSetValues(inv_entry[3], XtNlabel,str1,NULL);
		XtVaSetValues(inv_entry[4], XtNlabel,str2,NULL);
	}
}
/* invariants */
static void KnotGroup_C(){(void)InvSelectM(0);}
static void AlexPoly_C(){(void)InvSelectM(1);}
static void ConwayPoly_C(){(void)InvSelectM(2);}
static void Ppoly_C(){ (void)InvSelectM(3);}
static void PpolyLow_C(){(void)InvSelectM(4);}
static void Vpoly_C(){(void)InvSelectM(5);}
static void Fpoly_C(){(void)InvSelectM(6);}
static void Qpoly_C(){(void)InvSelectM(7);}
static void VpolyPara_C(){ 
	if( InvSelectM(8) ){ popup_proc_paraV(toplevel, popup_paraV_shell); }
}
static void AlexPolyM_C(){(void)InvSelectM(9);} // Multi variable
static void AlexIdeal_C(){(void)InvSelectM(10);}
static void AlexIdealM_C(){(void)InvSelectM(11);} // Multi variable
static void Covering_C(){ 
	if( InvSelectM(12) ){ popup_rep_proc(toplevel, popup_rep_shell); } 
}
static void Sl2p_C(){ 
	if( InvSelectM(13) ){ popup_proc_sl2p(toplevel, popup_sl2p_shell); }
}
static void GoeritzMat_C(){(void)InvSelectM(14);} // Goeritz matrix and knot value
static void Signature_C(){(void)InvSelectM(15);}
static void CyclicPeriod_C(){(void)InvSelectM(16);}
static void ThetaGroup_C(){(void)InvSelectM(17);}
static void ThetaAlexPoly_C(){(void)InvSelectM(18);}


static void OtherSelect(Widget w, int selection)
{
	char str[50];
	int reply;
	/*reply=OtherSelectM(selection);*/
	reply=OtherSelectM(selection);
	if(selection==0){
		if (reply==1){ sprintf(str, "Smooth Draw:  on");
		}else{ sprintf(str, "Smooth Draw: off");
		}
		XtVaSetValues(other_entry[0], XtNlabel,str,NULL);
	}else if(selection==1){
		if(reply==1){ sprintf(str, "Lattice move:  on");
		}else{ sprintf(str, "Lattice move:   off");
		}
		XtVaSetValues(other_entry[1], XtNlabel,str,NULL);
	}
}
/* other/miscellaneous actions */
static void O_Smooth_C(){OtherSelect(toplevel,0);}
static void O_Lattice_C(){OtherSelect(toplevel,1);}


static void repaint(){KNOTXW_repaint();}

static void TrackPointer(Widget w, XEvent *ev)
{
	char str[50];
	int cur_x,cur_y;
	cur_x = ev->xmotion.x; cur_y = ev->xmotion.y;
	sprintf(str,"(x y)=(%d %d)", cur_x,cur_y);
	XtVaSetValues(tracker, XtNlabel,str,NULL);
	/*KNOTXW_TrackEventM(ev->type, ev->xbutton.button,cur_x,cur_y);*/
	TrackEventM(ev->type, ev->xbutton.button,cur_x,cur_y);
}


/*==================  pixmap ===============================*/

static Pixmap Xpix;

static void create_pixmap_K(Widget w){
	/* set Xpix and pixgc */
	Dimension width,height;
    XtVaGetValues(w,XtNwidth,&width,XtNheight,&height,NULL);
	Xpix=XCreatePixmap(XtDisplay(w),XtWindow(w),
					   width,height,DefaultDepthOfScreen(XtScreen(w)));
}

static void free_pixmap(Widget w){
	XFreePixmap(XtDisplay(w),Xpix);
}



static void ResizeWindow()
{
	Dimension width,height;
	XtVaGetValues(canvas,XtNwidth,&width, XtNheight, &height, NULL);
	GraphWidthC = width; GraphHeightC=height;
	free_pixmap(canvas); create_pixmap_K(canvas);
	//  XFillRectangle(XtDisplay(w),Xpix,pixgcb,0,0,width,height);
	XFillRectangle(disp,Xpix,gcs[0],0,0,width,height);
	repaint();
}


/*=======================================================*/

static int WindowSwC=1;/* 1:screen  0:pixel */

int GraphWidth(){ return GraphWidthC; }
int GraphHeight(){ return GraphHeightC; }
void WindowSw(INT s){  WindowSwC=(int)s; }

/* copy from pixel to window */
INT FlushPixel(void)
{
	if(WindowSwC==1){
	}else{
		/*	XCopyArea(XtDisplay(w),Xpix,XtWindow(w),DefaultGC(XtDisplay(w),0),
		 *		  0,0,width,height,0,0);
		 */
		XCopyArea(disp,Xpix, canvasWindow , DefaultGC(XtDisplay(canvas),0),
				  0,0,GraphWidthC,GraphHeightC,0,0);
	}
	return WindowSwC;
}

void DrawLine(int x1,int y1,int x2,int y2,int palet)
{
	/*
	 *	XDrawLine(XtDisplay(w),Xpix,pixgcf, 0,0,width,height);
	 */
	if(WindowSwC==1){
		XDrawLine(disp, canvasWindow, gcs[palet], x1,y1,x2,y2);
	}else{
		XDrawLine(disp,Xpix, gcs[palet], x1,y1,x2,y2);
	}
}

void DrawCircle(int x, int y, int r, int palet, unsigned char fill)
{
	if(WindowSwC==1){
		fill ? XFillArc(disp,canvasWindow,gcs[palet],x-r,y-r,2*r,2*r,0,360*64) :
			XDrawArc(disp,canvasWindow ,gcs[palet],x-r,y-r,2*r,2*r,0,360*64);
	}else{
		fill ? XFillArc(disp,Xpix,gcs[palet],x-r,y-r,2*r,2*r,0,360*64) :
			XDrawArc(disp,Xpix,gcs[palet],x-r,y-r,2*r,2*r,0,360*64);
	}
}

void DrawPoint(int x, int y, int palet)
{
	if(WindowSwC==1){
		XDrawPoint(disp,canvasWindow ,gcs[palet], x,y);
	}else{
		XDrawPoint(disp,Xpix,gcs[palet], x,y);
	}
}

INT ClearWindow(void)
{
	if(WindowSwC==1){
		XClearWindow(disp, canvasWindow );
	}else{
		XFillRectangle(disp,Xpix,gcs[0],0,0,GraphWidthC,GraphHeightC);
	}
	return WindowSwC;
}

/* end */
