unit pic;   { programmed by Masaaki Wada, December 21, 1990 }

interface

var
	picRct: Rect;

procedure openPic (width, height: integer);
procedure closePic;
procedure showPic;
procedure scrapPic;

procedure setScale (xmin, xmax, ymin, ymax: extended);
procedure convert (x, y: extended; var i, j: integer);


implementation

var
	thePicture: PicHandle;
	saveRgn: RgnHandle;
	scale, xorg, yorg: extended;

procedure openPic (width, height: integer);
	begin
		saveRgn := NewRgn;
		GetClip(saveRgn);
		SetRect(picRct, 0, 0, width, height);
		ClipRect(picRct);
		thePicture := OpenPicture(picRct);
	end;

procedure closePic;
	begin
		ClosePicture;
		SetClip(saveRgn);
		DisposeRgn(saveRgn)
	end;

procedure showPic;
	var
		hratio, vratio, ratio: real;
		h, v: integer;
		r: Rect;
	begin
		with screenbits.bounds do
			begin
				hratio := (right - left - 25) / picRct.right;
				vratio := (bottom - top - 65) / picRct.bottom;
			end;
		if hratio < vratio then
			ratio := hratio
		else
			ratio := vratio;
		with picRct do
			begin
				h := trunc(ratio * right);
				v := trunc(ratio * bottom)
			end;
		SetRect(r, 5, 45, h + 20, v + 60);
		SetDrawingRect(r);
		ShowDrawing;
		SetRect(r, 0, 0, h, v);
		DrawPicture(thePicture, r);
	end;

procedure scrapPic;
	var
		dummy, len: longint;
	begin
		dummy := ZeroScrap;
		len := GetHandleSize(Handle(thePicture));
		dummy := PutScrap(len, 'PICT', Ptr(thePicture^))
	end;


procedure setScale (xmin, xmax, ymin, ymax: extended);
	var
		t: extended;
	begin
		scale := picRct.right / (xmax - xmin);
		t := picRct.bottom / (ymax - ymin);
		if scale > t then
			scale := t;
		xorg := picRct.right / 2 - (xmax + xmin) * scale / 2;
		yorg := picRct.bottom / 2 - (ymax + ymin) * scale / 2
	end;

procedure convert (x, y: extended; var i, j: integer);
	begin
		i := round(xorg + x * scale);
		j := round(yorg - y * scale)
	end;


end.